diff -r -uw -N irrlicht/source/Irrlicht/CD3D9MDriver.h irrlicht_multipatch/source/Irrlicht/CD3D9MDriver.h
--- irrlicht/source/Irrlicht/CD3D9MDriver.h	1970-01-01 01:00:00.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CD3D9MDriver.h	2006-12-11 12:34:37.000000000 +0100
@@ -0,0 +1,367 @@
+// Copyright (C) 2002-2006 Nikolaus Gebhardt
+// This file is part of the "Irrlicht Engine".
+// For conditions of distribution and use, see copyright notice in irrlicht.h
+
+#ifndef __C_VIDEO_DIRECTX_9_H_INCLUDED__
+#define __C_VIDEO_DIRECTX_9_H_INCLUDED__
+
+#include "IrrCompileConfig.h"
+
+#ifdef _IRR_WINDOWS_
+#define WIN32_LEAN_AND_MEAN
+#include "CNullDriver.h"
+#include <windows.h>
+#include "IMaterialRendererServices.h"
+
+#define MAX_DEPTH_FORMATS 5
+#define MAX_MODES 200
+#define MAX_ADAPTERS 16
+
+#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
+#include <d3d9.h>
+
+namespace irr
+{
+namespace video
+{
+	// Display mode description and its supported depth formats.
+	typedef struct
+	{
+		D3DDISPLAYMODE DisplayMode;
+		UINT iNumDepthFormats;
+		D3DFORMAT DepthFormats[MAX_DEPTH_FORMATS];
+		D3DFORMAT *CurrDepthFormat;
+	} MODE_INFO;
+
+	// Adapter information.
+	typedef struct
+	{
+		char DeviceName[MAX_DEVICE_IDENTIFIER_STRING];
+		UINT AdapterID;
+		UINT Ordinal;
+		UINT iNumModes;
+		MODE_INFO Modes[MAX_MODES];
+		MODE_INFO *CurrMode;
+		TCHAR CurrModeDescr[50];
+		LPDIRECT3DSURFACE9 pDepthStencil;
+		D3DSURFACE_DESC sdBackBuffer;
+	} ADAPTER_INFO;
+
+	// Multihead capable device description.
+	typedef struct
+	{
+		ADAPTER_INFO Adapters[MAX_ADAPTERS];
+		UINT iNumAdapters;
+	} DEVICE_INFO;
+}
+}
+
+namespace irr
+{
+namespace video
+{
+	class CD3D9MDriver : public CNullDriver, IMaterialRendererServices
+	{
+	public:
+
+		//! constructor
+		CD3D9MDriver(const core::dimension2d<s32>& screenSize, HWND window, bool fullscreen,
+			bool stencibuffer, io::IFileSystem* io, bool pureSoftware=false);
+
+		//! destructor
+		virtual ~CD3D9MDriver();
+
+		//! applications must call this method before performing any rendering. returns false if failed.
+		virtual bool beginScene(bool backBuffer, bool zBuffer, SColor color);
+
+		//! applications must call this method after performing any rendering. returns false if failed.
+		virtual bool endScene( s32 windowId = 0, core::rect<s32>* sourceRect=0 );
+
+		//! queries the features of the driver, returns true if feature is available
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
+
+		//! sets transformation
+		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
+
+		//! sets a material
+		virtual void setMaterial(const SMaterial& material);
+
+		//! sets a render target
+		virtual bool setRenderTarget(video::ITexture* texture,
+			bool clearBackBuffer=false, bool clearZBuffer=false,
+			SColor color=video::SColor(0,0,0,0));
+
+		//! sets a viewport
+		virtual void setViewPort(const core::rect<s32>& area);
+
+		//! gets the area of the current viewport
+		virtual const core::rect<s32>& getViewPort() const;
+
+		//! draws a vertex primitive list
+		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+
+		//! draws an 2d image, using a color (if color is other then Color(255,255,255,255)) and the alpha channel of the texture if wanted.
+		virtual void draw2DImage(video::ITexture* texture, const core::position2d<s32>& destPos,
+			const core::rect<s32>& sourceRect, const core::rect<s32>* clipRect = 0,
+			SColor color=SColor(255,255,255,255), bool useAlphaChannelOfTexture=false);
+
+		//! Draws a part of the texture into the rectangle.
+		virtual void draw2DImage(video::ITexture* texture, const core::rect<s32>& destRect,
+			const core::rect<s32>& sourceRect, const core::rect<s32>* clipRect = 0,
+			video::SColor* colors=0, bool useAlphaChannelOfTexture=false);
+
+		//!Draws an 2d rectangle with a gradient.
+		virtual void draw2DRectangle(const core::rect<s32>& pos,
+			SColor colorLeftUp, SColor colorRightUp, SColor colorLeftDown, SColor colorRightDown,
+			const core::rect<s32>* clip);
+
+		//! Draws a 2d line.
+		virtual void draw2DLine(const core::position2d<s32>& start,
+					const core::position2d<s32>& end,
+					SColor color=SColor(255,255,255,255));
+
+		//! Draws a 3d line.
+		virtual void draw3DLine(const core::vector3df& start,
+			const core::vector3df& end, SColor color = SColor(255,255,255,255));
+
+		//! initialises the Direct3D API for multihead support.
+		bool initDriver(const core::array<core::dimension2d<s32> >& screenSize, core::array<HWND> hwnd,
+						u32 bits, bool fullScreen, bool pureSoftware, bool highPrecisionFPU, bool vsync, bool antiAlias);
+
+		//! \return Returns the name of the video driver. Example: In case of the DIRECT3D8
+		//! driver, it would return "Direct3D8.1".
+		virtual const wchar_t* getName();
+
+		//! deletes all dynamic lights there are
+		virtual void deleteAllDynamicLights();
+
+		//! adds a dynamic light
+		virtual void addDynamicLight(const SLight& light);
+
+		//! returns the maximal amount of dynamic lights the device can handle
+		virtual s32 getMaximalDynamicLightAmount();
+
+		//! Sets the dynamic ambient light color. The default color is
+		//! (0,0,0,0) which means it is dark.
+		//! \param color: New color of the ambient light.
+		virtual void setAmbientLight(const SColorf& color);
+
+		//! Draws a shadow volume into the stencil buffer. To draw a stencil shadow, do
+		//! this: Frist, draw all geometry. Then use this method, to draw the shadow
+		//! volume. Then, use IVideoDriver::drawStencilShadow() to visualize the shadow.
+		virtual void drawStencilShadowVolume(const core::vector3df* triangles, s32 count, bool zfail);
+
+		//! Fills the stencil shadow with color. After the shadow volume has been drawn
+		//! into the stencil buffer using IVideoDriver::drawStencilShadowVolume(), use this
+		//! to draw the color of the shadow.
+		virtual void drawStencilShadow(bool clearStencilBuffer=false,
+			video::SColor leftUpEdge = video::SColor(0,0,0,0),
+			video::SColor rightUpEdge = video::SColor(0,0,0,0),
+			video::SColor leftDownEdge = video::SColor(0,0,0,0),
+			video::SColor rightDownEdge = video::SColor(0,0,0,0));
+
+		//! Returns the maximum amount of primitives (mostly vertices) which
+		//! the device is able to render with one drawIndexedTriangleList
+		//! call.
+		virtual s32 getMaximalPrimitiveCount();
+
+		//! Enables or disables a texture creation flag.
+		virtual void setTextureCreationFlag(E_TEXTURE_CREATION_FLAG flag, bool enabled);
+
+		//! Sets the fog mode.
+		virtual void setFog(SColor color, bool linearFog, f32 start,
+			f32 end, f32 density, bool pixelFog, bool rangeFog);
+
+		//! Only used by the internal engine. Used to notify the driver that
+		//! the window was resized.
+		virtual void OnResize(const core::dimension2d<s32>& size);
+
+		//! Can be called by an IMaterialRenderer to make its work easier.
+		virtual void setBasicRenderStates(const SMaterial& material, const SMaterial& lastMaterial,
+			bool resetAllRenderstates);
+
+		//! Returns type of video driver
+		virtual E_DRIVER_TYPE getDriverType();
+
+		//! Returns the transformation set by setTransform
+		virtual const core::matrix4& getTransform(E_TRANSFORMATION_STATE state);
+
+		//! Sets a vertex shader constant.
+		virtual void setVertexShaderConstant(const f32* data, s32 startRegister, s32 constantAmount=1);
+
+		//! Sets a pixel shader constant.
+		virtual void setPixelShaderConstant(const f32* data, s32 startRegister, s32 constantAmount=1);
+
+		//! Sets a constant for the vertex shader based on a name.
+		virtual bool setVertexShaderConstant(const c8* name, const f32* floats, int count);
+
+		//! Sets a constant for the pixel shader based on a name.
+		virtual bool setPixelShaderConstant(const c8* name, const f32* floats, int count);
+
+		//! Returns pointer to the IGPUProgrammingServices interface.
+		virtual IGPUProgrammingServices* getGPUProgrammingServices();
+
+		//! Returns a pointer to the IVideoDriver interface. (Implementation for
+		//! IMaterialRendererServices)
+		virtual IVideoDriver* getVideoDriver();
+
+		//! Creates a render target texture.
+		virtual ITexture* createRenderTargetTexture(const core::dimension2d<s32>& size);
+
+		//! Clears the ZBuffer.
+		virtual void clearZBuffer();
+
+		//! Returns an image created from the last rendered frame.
+		virtual IImage* createScreenShot();
+
+		//! Returns the count of multihead devices.
+		int getMultiheadDevicesCount();
+	private:
+
+		//! initialises the Direct3D Interface.
+		bool initDirect3DInterface();
+
+		//! find and initialises multihead informations
+		bool findMultiHeadDevice();
+		
+		//! create and init list of presentation parameters.
+		void buildPresentParams(const core::array<core::dimension2d<s32> >& screenSize, core::array<HWND> hwnd, u32 bits, bool vsync);
+
+		//! begins a part scene.
+		bool beginPartScene();
+		
+		//! ends a part scene.
+		bool endPartScene();
+
+		// enumeration for rendering modes such as 2d and 3d for minizing the switching of renderStates.
+		enum E_RENDER_MODE
+		{
+			ERM_NONE = 0,	// no render state has been set yet.
+			ERM_2D,			// 2d drawing rendermode
+			ERM_3D,			// 3d rendering mode
+			ERM_STENCIL_FILL, // stencil fill mode
+			ERM_SHADOW_VOLUME_ZFAIL, // stencil volume draw mode
+			ERM_SHADOW_VOLUME_ZPASS // stencil volume draw mode
+		};
+
+		//! sets right vertex shader
+		void setVertexShader(video::E_VERTEX_TYPE newType);
+
+		//! sets the needed renderstates
+		bool setRenderStates3DMode();
+
+		//! sets the needed renderstates
+		void setRenderStates2DMode(bool alpha, bool texture, bool alphaChannel);
+
+		//! sets the needed renderstates
+		void setRenderStatesStencilFillMode(bool alpha);
+
+		//! sets the needed renderstates
+		void setRenderStatesStencilShadowMode(bool zfail);
+
+		//! sets the current Texture
+		bool setTexture(s32 stage, video::ITexture* texture);
+
+		//! resets the device
+		bool reset();
+
+		//! returns a device dependent texture from a software surface (IImage)
+		//! THIS METHOD HAS TO BE OVERRIDDEN BY DERIVED DRIVERS WITH OWN TEXTURES
+		virtual video::ITexture* createDeviceDependentTexture(IImage* surface, const char* name);
+
+		// returns the current size of the screen or rendertarget
+		core::dimension2d<s32> getCurrentRenderTargetSize();
+
+		//! Adds a new material renderer to the VideoDriver, using pixel and/or
+		//! vertex shaders to render geometry.
+		s32 addShaderMaterial(const c8* vertexShaderProgram, const c8* pixelShaderProgram,
+			IShaderConstantSetCallBack* callback,
+			E_MATERIAL_TYPE baseMaterial, s32 userData);
+
+		//! Adds a new material renderer to the VideoDriver, based on a high level shading
+		//! language.
+		virtual s32 addHighLevelShaderMaterial(
+			const c8* vertexShaderProgram,
+			const c8* vertexShaderEntryPointName = "main",
+			E_VERTEX_SHADER_TYPE vsCompileTarget = EVST_VS_1_1,
+			const c8* pixelShaderProgram = 0,
+			const c8* pixelShaderEntryPointName = "main",
+			E_PIXEL_SHADER_TYPE psCompileTarget = EPST_PS_1_1,
+			IShaderConstantSetCallBack* callback = 0,
+			E_MATERIAL_TYPE baseMaterial = video::EMT_SOLID,
+			s32 userData=0);
+
+		void createMaterialRenderers();
+
+		inline D3DCOLORVALUE colorToD3D(const SColor& col)
+		{
+			const f32 f = 1.0f / 255.0f;
+			D3DCOLORVALUE v;
+			v.r = col.getRed() * f;
+			v.g = col.getGreen() * f;
+			v.b = col.getBlue() * f;
+			v.a = col.getAlpha() * f;
+			return v;
+		}
+
+
+		E_RENDER_MODE CurrentRenderMode;
+
+		core::array<core::matrix4*> Matricess;
+
+		core::array<SMaterial> Materials;
+		core::array<SMaterial> LastMaterials;
+
+		core::array<bool> ResetRenderStatess;
+
+		bool Transformation3DChanged;
+		bool StencilBuffer;
+		bool LastTextureMipMapsAvailable[MATERIAL_MAX_TEXTURES];
+		ITexture* CurrentTexture[MATERIAL_MAX_TEXTURES];
+
+		HINSTANCE D3DLibrary;
+		IDirect3D9* pID3D;
+		IDirect3DDevice9* pID3DDevice;
+
+		//we use multiple devices
+		core::array<IDirect3DDevice9*> pID3DDevices;
+
+		IDirect3DSurface9* PrevRenderTarget;
+		core::dimension2d<s32> CurrentRendertargetSize;
+
+		core::array<D3DCAPS9> Capss;
+
+		core::array<E_VERTEX_TYPE> LastVertexTypes;
+
+		f32 MaxLightDistance;
+		core::array<s32> LastSetLights;
+		bool DeviceLost;
+		bool Fullscreen;
+
+		SColorf AmbientLight;
+
+		bool BackBuffer;
+		bool ZBuffer;
+		SColor Color;
+
+		MODE_INFO *m_curMode;
+		DEVICE_INFO m_Device;
+		core::array<D3DPRESENT_PARAMETERS*> m_pPresentParams;
+		u32 m_renderAdapter;
+		bool m_beginScene;
+
+		core::array<LPDIRECT3DSURFACE9> m_pRenderTargets;
+
+		LPDIRECT3DSWAPCHAIN9 m_pSwapChain;
+		LPDIRECT3DSURFACE9 m_pBackBuffer;
+	};
+
+
+} // end namespace video
+} // end namespace irr
+
+
+#endif // _IRR_COMPILE_WITH_DIRECT3D_9_
+#endif // _IRR_WINDOWS_
+#endif // __C_VIDEO_DIRECTX_8_H_INCLUDED__
+
